#include "timerfunctions.h"

SIGNAL (SIG_OVERFLOW1) {				//Zeitberechnung, Alarmberwachung

	if (time_display) {
		display_array[0] = stunden_h;
		display_array[1] = stunden_l;
		display_array[2] = minuten_h;
		display_array[3] = minuten_l;
	}
	
	sekunden_l++;						//Berechnung der Uhrzeit
	if (sekunden_l == 58) {
		sekunden_l = '0';
		sekunden_h++;
		if (sekunden_h == '6') {
			sekunden_h = '0';
			minuten_l++;
			if (minuten_l == 58) {
				minuten_l = '0';
				minuten_h++;
				if (minuten_h == '6') {
					minuten_h = '0';
					stunden_l++;
					if (stunden_l == 58) {
						stunden_l = '0';
						stunden_h++;
					}
					if (stunden_h == '2'){
						if (stunden_l == '4') {
							stunden_h = '0';
							stunden_l = '0';
						}
					}
				}	
			}
			
		}
	}
	
	if (alarm_activate) {				//Prfung ob Uhrzeit = Weckzeit
		if (stunden_h == wake_std_h) {
			if (stunden_l == wake_std_l) {
				if (minuten_h == wake_min_h) {
					if (minuten_l == wake_min_l) {
						wake_enable = 1;		//Alarm auslsen
					}
				}
			}
		}
	}
	
	if (wake_enable)
		ring_ring_count++;					//Begrenzung der Alarmdauer
	
	TCNT1 = 34286;							//Vorladen des Zhlregisters
}

SIGNAL (SIG_OVERFLOW2) {					//mit 488Hz Wechsel zwischen 7-Segment-Anzeigen
	_7_segment_rotate ();
}

void delay (unsigned int us) {			//simple Delay-Routine fr kurze Wartezeiten
    while ( us ) us--;
}

void time_init (void) {
	DDRB = (1<<PB3) | (1<<PB4);			//LED-Doppelpunkt fr DCF77-Signalisierung
	//Timer1
	TIMSK |= (1<<TOIE1);            		//Timer Overflow Interrupt enable
	TCNT1 = 34286;                			//Rcksetzen des Timers
	TCCR1B |= (1<<CS12);				    //Prescaler 256
	//Timer2
	TIMSK |= (1<<TOIE2);
	//TCCR2 |= (1<<CS21);					//Prescaler 8
	TCCR2 |= (1<<CS22);						//Prescaler 64
}

void wake_up (void) {
	time_display = 0;						//Austausch der Uhrzeit gegen die
	display_array[0] = wake_std_h;			//Weckzeit auf den Anzeigen
	display_array[1] = wake_std_l;
	display_array[2] = wake_min_h;
	display_array[3] = wake_min_l;
	
	if (!(PINB & (1<<PB1))) {				//Minuten erhhen und berlauf prfen
		wake_min_l++;
		if (wake_min_l == 58) {
			wake_min_l = '0';
			wake_min_h++;
			if (wake_min_h == '6') {
				wake_min_h = '0';
				wake_min_l = '0';
			}
		}
	}
	
	if (!(PINB & (1<<PB2))) {				//Stunden erhhen und berlauf prfen
		wake_std_l++;
		if (wake_std_l == 58) {
			wake_std_l = '0';
			wake_std_h++;
		}
		if (wake_std_h == '2'){
			if (wake_std_l == '4') {
				wake_std_h = '0';
				wake_std_l = '0';
			}
		}
	}
	int i = 0;
	for (i=0; i<10; i++)					//Wartezeit, damit Min. und Std. nicht zu schnell hochlaufen
		delay (65000);
	
	time_display = 1;						//zurck zur Uhrzeit auf Display
}

void ring_ring (void) {
	DDRC |= (1<<PC5);						//drcken jeglicher Taste fhrt zu Alarmende
	while ((PINB & (1<<PB0)) && (PINB & (1<<PB1)) && (PINB & (1<<PB2))) {
		PORTC |= (1<<PC5);					//"Software-PWM"
		delay (1000);
		PORTC &= ~(1<<PC5);
		delay (1000);
		if (ring_ring_count == 120) {		//Prfen der max. Alarmzeit
			ring_ring_count = 0;
			wake_enable = 0;
			alarm_activate = 0;
			PORTC &= ~(1<<PC5);
			return;
		}
	}
	wake_enable = 0;
	alarm_activate = 0;						//deaktivieren des Alarms
	PORTC &= ~(1<<PC5);
	PORTC |= (1<<PC4);
}
